#include "Module.h"

#include "Peep.h"

#include "Main_window.h"
#include "Model.h"
#include "Model_kit.h"

#include "Abstracts.h"
#include "Create.h"

namespace MM
{

class Module_Qt : public Module
{
    static Module_Qt        singleton_;
                            Module_Qt() ;
    void                    init ();
};
Module_Qt  Module_Qt::singleton_;


Module_Qt::Module_Qt () : Module ("Qt") { }

void  Module_Qt::
init ()
{
    struct Tile : public Command
    {void execute() {Main_window::singleton()->MDI_panel->tileSubWindows();}};

    struct Cascade : public Command
    {void execute() {Main_window::singleton()->MDI_panel->cascadeSubWindows();}};

    adopt_command (new Tile)
        //.set_icon       ("Window", "tile.png")
        .set_tool_tip   ("Tile windows.")
        .set_menu       ("&Window", "&Tile");

    adopt_command (new Cascade)
        //.set_icon       ("Window", "cascade.png")
        .set_tool_tip   ("Cascade windows.")
        .set_menu       ("&Window", "&Cascade");

    //adopt_command (prototype <Open> ().clone())
    //    .set_icon       ("File", "open.png")
    //    .set_tool_tip   ("Load model from file.")
    //    .set_menu       ("&File", "&Open");

    //insert_menu_separator ("&File");
}

}//MM
