#ifndef SI_SYSTEM_OF_UNITS_H
#define SI_SYSTEM_OF_UNITS_H

#ifndef SYSTEM_OF_UNITS_H
#include "System_of_Units.h"
#endif

namespace MM
{

class SI_System_of_Units : public System_of_Units
{
public:
    virtual double      length  (Length_unit const & v) const {return v.m();}
    //virtual double      energy  () const = 0;
    //virtual double      mass    () const = 0;
    //virtual double      charge  () const = 0;
    virtual double      time    (Duration_unit const & v) const {return v.sec();}
    //virtual double      force   () const = 0;
    //virtual double      electric_conversion_factor() const = 0;
};

}//MM

#endif //SI_SYSTEM_OF_UNITS_H
