#ifndef OPVL_H
#define OPVL_H

#ifndef OVL_H
#include "OVL.h"
#endif

namespace MM
{
                                                                         
class OPVL : public OVL 
{
public:
    explicit OPVL (Prototype const &) {adopt_prototype (this);}
    explicit OPVL () { }
    //explicit OPVL (MD_subject & subject) : OVL (subject) { }
    char const *    class_name () const {return "OPVL";}
    MD_method *     clone () const      {return new OPVL;}

protected:
    virtual Text const& title () const
    {
        static const Text name ="Optimized Position Verlet-Like";
        return name;
    }

    virtual void start ()
    {
        MD_method::start ();
        F ();
    }

    virtual void        step   ()
    {
        drift (xi());

        F ();
        kick  (0.5);

        drift (1.-2.*xi());

        F ();
        kick  (0.5);

        drift (xi());
    }
};

}//MM

#endif //OPVL_H
