#ifndef POSITION_VERLET_H
#define POSITION_VERLET_H

#ifndef LEAPFROG_H
#include "Leapfrog.h"
#endif

namespace MM
{

class Position_verlet : public Leapfrog
{
public:
    explicit Position_verlet (Prototype const &) {adopt_prototype (this);}
    explicit Position_verlet () { }
    //explicit Position_verlet (MD_subject & subject) : Leapfrog (subject) { }
    char const *    class_name () const {return "Position_verlet";}
    MD_method *     clone () const      {return new Position_verlet;}

protected:
    virtual Text const& title () const
    {
        static const Text name = "Position Verlet";
        return name;
    }

    virtual void        step   ()
    {
        drift (.5);
        F ();
        kick  (1.);
        drift (.5);
    }
};

}//MM

#endif //POSITION_VERLET_H
