#ifndef VELOCITY_VERLET_H
#define VELOCITY_VERLET_H

#ifndef LEAPFROG_H
#include "Leapfrog.h"
#endif

namespace MM
{

class Velocity_verlet : public Leapfrog
{
public:
    explicit Velocity_verlet (Prototype const &) {adopt_prototype (this);}
    explicit Velocity_verlet () { }
    //explicit Velocity_verlet (MD_subject & subject) : Leapfrog (subject) { }

    char const *    class_name () const {return "Velocity_verlet";}
    MD_method *     clone () const      {return new Velocity_verlet;}

protected:
    virtual Text const& title () const
    {
        static const Text name = "Velocity Verlet";
        return name;
    }

    virtual void start ()
    {
        MD_method::start ();
        F ();
    }

    virtual void        step   ()
    {
        //F ();
        kick  (.5);
        drift (1.);
        F ();
        kick  (.5);
    }
};

}//MM

#endif //VELOCITY_VERLET_H
